Loading...
Searching...
No Matches
juce::CriticalSection Class Reference

`#include <juce_CriticalSection.h>`

Inheritance diagram for juce::CriticalSection:

## Public Types

using | ScopedLockType = GenericScopedLock<CriticalSection>
using | ScopedUnlockType = GenericScopedUnlock<CriticalSection>
using | ScopedTryLockType = GenericScopedTryLock<CriticalSection>

## Public Member Functions

| CriticalSection () noexcept
| ~CriticalSection () noexcept
void | enter () const noexcept
bool | tryEnter () const noexcept
void | exit () const noexcept

## Detailed Description

A re-entrant mutex.

A CriticalSection acts as a re-entrant mutex object. The best way to lock and unlock one of these is by using RAII in the form of a local ScopedLock object - have a look through the codebase for many examples of how to do this.

In almost all cases you'll want to declare your CriticalSection as a member variable. Occasionally you may want to declare one as a static variable, but in that case the usual C++ static object order-of-construction warnings should be heeded.

See also
  ScopedLock, ScopedTryLock, ScopedUnlock, SpinLock, ReadWriteLock, Thread, InterProcessLock

Definition at line 42 of file juce_CriticalSection.h.

## Member Typedef Documentation

## ScopedLockType

using juce::CriticalSection::ScopedLockType = GenericScopedLock<CriticalSection>

Provides the type of scoped lock to use with a CriticalSection.

Definition at line 93 of file juce_CriticalSection.h.

## ScopedTryLockType

using juce::CriticalSection::ScopedTryLockType = GenericScopedTryLock<CriticalSection>

Provides the type of scoped try-locker to use with a CriticalSection.

Definition at line 99 of file juce_CriticalSection.h.

## ScopedUnlockType

using juce::CriticalSection::ScopedUnlockType = GenericScopedUnlock<CriticalSection>

Provides the type of scoped unlocker to use with a CriticalSection.

Definition at line 96 of file juce_CriticalSection.h.

## Constructor & Destructor Documentation

## CriticalSection()

juce::CriticalSection::CriticalSection | ( |  | ) |

noexcept

Creates a CriticalSection object.

Referenced by ~CriticalSection().

## ~CriticalSection()

juce::CriticalSection::~CriticalSection | ( |  | ) |

noexcept

Destructor. If the critical section is deleted whilst locked, any subsequent behaviour is unpredictable.

## Member Function Documentation

## enter()

void juce::CriticalSection::enter | ( |  | ) | const

noexcept

Acquires the lock.

If the lock is already held by the caller thread, the method returns immediately. If the lock is currently held by another thread, this will wait until it becomes free.

It's strongly recommended that you never call this method directly - instead use the ScopedLock class to manage the locking using an RAII pattern instead.

See also
  exit, tryEnter, ScopedLock

Referenced by enter().

## exit()

void juce::CriticalSection::exit | ( |  | ) | const

noexcept

Releases the lock.

If the caller thread hasn't got the lock, this can have unpredictable results.

If the enter() method has been called multiple times by the thread, each call must be matched by a call to exit() before other threads will be allowed to take over the lock.

See also
  enter, ScopedLock

Referenced by exit().

## tryEnter()

bool juce::CriticalSection::tryEnter | ( |  | ) | const

noexcept

Attempts to lock this critical section without blocking.

This method behaves identically to CriticalSection::enter, except that the caller thread does not wait if the lock is currently held by another thread but returns false immediately.

Returns
  false if the lock is currently held by another thread, true otherwise.

See also
  enter

Referenced by tryEnter().

The documentation for this class was generated from the following file:

- juce_CriticalSection.h